## ros-indigo-schunk-canopen-driver 1.0.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

SET(ICMAKER_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/icmaker")
INCLUDE(${ICMAKER_DIRECTORY}/CMakeLists.txt)

project(schunk_canopen_driver)

FIND_PACKAGE( icl_core REQUIRED)
FIND_PACKAGE( icl_hardware_can REQUIRED)
FIND_PACKAGE( icl_comm OPTIONAL_COMPONENTS icl_comm_websocket)
ADD_SUBDIRECTORY (src/icl_hardware_canopen)
FIND_PACKAGE( icl_hardware_canopen REQUIRED)


## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  actionlib
  control_msgs
  controller_manager
  hardware_interface
  joint_limits_interface
  message_generation
  roscpp
  sensor_msgs
  std_msgs
  std_srvs
  urdf
)



# generate_dynamic_reconfigure_options(
#   cfg/schunk_canopen_driver_config.cfg
# )


add_definitions( ${icl_hardware_can_DEFINITIONS} )
add_definitions( ${icl_hardware_canopen_DEFINITIONS} )
add_definitions( ${icl_core_DEFINITIONS} )
add_definitions( ${icl_comm_DEFINITIONS} )

if(icl_comm_icl_comm_websocket_FOUND)
  message(STATUS "Building schunk_canopen_driver with icl_comm_websocket support.")
else()
  message(STATUS "Building schunk_canopen_driver without icl_comm_websocket support.")
endif()

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()

################################################
## Declare ROS messages, services and actions ##
################################################

## To declare and build messages, services or actions from within this
## package, follow these steps:
## * Let MSG_DEP_SET be the set of packages whose message types you use in
##   your messages/services/actions (e.g. std_msgs, actionlib_msgs, ...).
## * In the file package.xml:
##   * add a build_depend and a run_depend tag for each package in MSG_DEP_SET
##   * If MSG_DEP_SET isn't empty the following dependencies might have been
##     pulled in transitively but can be declared for certainty nonetheless:
##     * add a build_depend tag for "message_generation"
##     * add a run_depend tag for "message_runtime"
## * In this file (CMakeLists.txt):
##   * add "message_generation" and every package in MSG_DEP_SET to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * add "message_runtime" and every package in MSG_DEP_SET to
##     catkin_package(CATKIN_DEPENDS ...)
##   * uncomment the add_*_files sections below as needed
##     and list every .msg/.srv/.action file to be processed
##   * uncomment the generate_messages entry below
##   * add every package in MSG_DEP_SET to generate_messages(DEPENDENCIES ...)

## Generate messages in the 'msg' folder
# add_message_files(
#   FILES
#   Message1.msg
#   Message2.msg
# )

## Generate services in the 'srv' folder
add_service_files(
   FILES
   HomeAll.srv
   HomeWithIDs.srv
   HomeWithJointNames.srv
)

## Generate actions in the 'action' folder
# add_action_files(
#   FILES
#   Action1.action
#   Action2.action
# )

## Generate added messages and services with any dependencies listed here
generate_messages(
   DEPENDENCIES
   control_msgs
   sensor_msgs
   std_msgs
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES
  CATKIN_DEPENDS
    actionlib
    controller_manager
    hardware_interface
    joint_limits_interface
    message_runtime
    roscpp
    std_srvs
  DEPENDS
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
#include_directories(include)
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${icl_hardware_can_INCLUDE_DIRS}
  ${icl_hardware_canopen_INCLUDE_DIRS}
  ${icl_core_INCLUDE_DIRS}
  ${icl_comm_INCLUDE_DIRS}
)


## Declare a cpp executable
add_executable(schunk_canopen_driver_node
  src/SchunkCanopenNode.cpp
  src/SchunkCanopenHardwareInterface.cpp
)

## Add cmake target dependencies of the executable/library
## as an example, message headers may need to be generated before nodes
add_dependencies(schunk_canopen_driver_node ${PROJECT_NAME}_generate_messages_cpp)

## Specify libraries to link a library or executable target against
 target_link_libraries(schunk_canopen_driver_node
   ${icl_hardware_LIBRARIES}
   ${icl_hardware_canopen_LIBRARIES}
   ${icl_core_LIBRARIES}
   ${icl_comm_INCLUDE_DIRS}
   ${catkin_LIBRARIES}
 )


## Declare a cpp executable
add_executable(schunk_canopen_driver_move_home_node
  src/MoveToHomeNode.cpp
)

## Add cmake target dependencies of the executable/library
## as an example, message headers may need to be generated before nodes
add_dependencies(schunk_canopen_driver_move_home_node ${PROJECT_NAME}_generate_messages_cpp)

## Specify libraries to link a library or executable target against
 target_link_libraries(schunk_canopen_driver_move_home_node
   ${icl_hardware_LIBRARIES}
   ${icl_hardware_canopen_LIBRARIES}
   ${icl_core_LIBRARIES}
   ${icl_comm_INCLUDE_DIRS}
   ${catkin_LIBRARIES}
 )

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables and/or libraries for installation
 install(TARGETS schunk_canopen_driver_node schunk_canopen_driver_move_home_node
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
 )

## Mark cpp header files for installation
 install(DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
#   FILES_MATCHING PATTERN "*.h"
#   PATTERN ".svn" EXCLUDE
 )


#config files
install(DIRECTORY etc/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/etc)

#config files
install(DIRECTORY config/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/config)

#Meshes
install(DIRECTORY meshes/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/meshes)

#URDF
install(DIRECTORY urdf/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/urdf)

# install the launch files
install(DIRECTORY launch/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch)

## Mark other files for installation (e.g. launch and bag files, etc.)
# install(FILES
#   # myfile1
#   # myfile2
#   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
# )

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
# catkin_add_gtest(${PROJECT_NAME}-test test/test_ros_canopen_schunk_chain.cpp)
# if(TARGET ${PROJECT_NAME}-test)
#   target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME})
# endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

=== icmaker/CMakeLists.txt ===
# this is for emacs file handling -*- mode: cmake; indent-tabs-mode: nil -*-

# -- BEGIN LICENSE BLOCK ----------------------------------------------
# This file is part of the icmaker build system.
#
# This program is free software licensed under the BSD License. You can
# find a copy of this license in the LICENSE folder in the top directory
# of the source code.
#
# © Copyright 2016 FZI Forschungszentrum Informatik, Karlsruhe, Germany
# -- END LICENSE BLOCK ------------------------------------------------

# ----------------------------------------------------------------------------
#  Root CMake file for IcMaker
#
#    From the off-tree build directory, invoke:
#      $ cmake <PATH_TO_ICMAKER_ROOT>
#
#
#   - OCT-2010: Initial version <schamm@fzi.de>
#               Taken from OpenCV
#
# ----------------------------------------------------------------------------

SET(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)
# Add these standard paths to the search paths for FIND_LIBRARY
# to find libraries from these locations first
IF(UNIX)
  SET(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} /lib /usr/lib)
ENDIF()
# it _must_ go before PROJECT(IcMaker) in order to work
IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    IF(WIN32)
        SET(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR} CACHE PATH "Install path prefix, prepended onto install directories (default: CMAKE_BINARY_DIR)." FORCE)
    ELSE()
        SET(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}/export" CACHE PATH "Install path prefix, prepended onto install directories (default: ../export)." FORCE)
    ENDIF()
ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

SET(CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo" CACHE STRING "Configs" FORCE)
SET(CMAKE_C_FLAGS_MINSIZEREL "" CACHE INTERNAL "" FORCE)
SET(CMAKE_CXX_FLAGS_MINSIZEREL "" CACHE INTERNAL "" FORCE)
SET(CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "" CACHE INTERNAL "" FORCE)
SET(CMAKE_MODULE_LINKER_FLAGS_MINSIZEREL "" CACHE INTERNAL "" FORCE)
SET(CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL "" CACHE INTERNAL "" FORCE)
SET(CMAKE_VERBOSE OFF CACHE BOOL "Verbose mode")

IF(CMAKE_VERBOSE OR CMAKE_EXTRA_GENERATOR MATCHES "Eclipse CDT.*")
    SET(CMAKE_VERBOSE_MAKEFILE ON)
ENDIF()

IF(ICMAKER_PROJECT_NAME)
  SET(ICMAKER_PROJECT_NAME ${ICMAKER_PROJECT_NAME} CACHE INTERNAL "")
ELSE()
  SET(ICMAKER_PROJECT_NAME IcMaker CACHE INTERNAL "")
ENDIF()
PROJECT(${ICMAKER_PROJECT_NAME})

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

IF(MSVC)
    SET(CMAKE_USE_RELATIVE_PATHS ON CACHE INTERNAL "" FORCE)
ENDIF()

# --------------------------------------------------------------
# Indicate CMake 2.7 and above that we don't want to mix relative
#  and absolute paths in linker lib lists.
# Run "cmake --help-policy CMP0003" for more information.
# --------------------------------------------------------------
IF(POLICY CMP0003)
    CMAKE_POLICY(SET CMP0003 NEW)
ENDIF()
IF(POLICY CMP0015)
    CMAKE_POLICY(SET CMP0015 NEW)
ENDIF()

# ----------------------------------------------------------------------------
#  Current version number:
# ----------------------------------------------------------------------------
SET(ICMAKER_VERSION "1.0.0")

STRING(REGEX MATCHALL "[0-9]" ICMAKER_VERSION_PARTS "${ICMAKER_VERSION}")

LIST(GET ICMAKER_VERSION_PARTS 0 ICMAKER_VERSION_MAJOR)
LIST(GET ICMAKER_VERSION_PARTS 1 ICMAKER_VERSION_MINOR)
LIST(GET ICMAKER_VERSION_PARTS 2 ICMAKER_VERSION_PATCH)

SET(ICMAKER_SOVERSION "${ICMAKER_VERSION_MAJOR}.${ICMAKER_VERSION_MINOR}")

IF(WIN32)
    # Postfix of DLLs:
    SET(ICMAKER_DLLVERSION "${ICMAKER_VERSION_MAJOR}${ICMAKER_VERSION_MINOR}${ICMAKER_VERSION_PATCH}")
    SET(ICMAKER_DEBUG_POSTFIX d)
ELSE()
    # Postfix of so's:
    #SET(ICMAKER_DLLVERSION "${ICMAKER_VERSION_MAJOR}${ICMAKER_VERSION_MINOR}${ICMAKER_VERSION_PATCH}")
    SET(ICMAKER_DLLVERSION "")
    SET(ICMAKER_DEBUG_POSTFIX)
ENDIF()


# ----------------------------------------------------------------------------
# Build static or dynamic libs?
# ----------------------------------------------------------------------------
# Default: dynamic libraries:
SET(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries (.dll/.so) instead of static ones (.lib/.a)")
IF(BUILD_SHARED_LIBS)
    SET(ICMAKER_BUILD_SHARED_LIB 1)
ELSE(BUILD_SHARED_LIBS)
    SET(ICMAKER_BUILD_SHARED_LIB 0)
	ADD_DEFINITIONS(-D_IC_STATIC_)

        # set /MT for windows static build according to http://www.cmake.org/Wiki/CMake_FAQ#How_can_I_build_my_MSVC_application_with_a_static_runtime.3F
        SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_RELEASE} /MTd")
        SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
        SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELEASE} /MT")

ENDIF(BUILD_SHARED_LIBS)

# ----------------------------------------------------------------------------
#  Variables for icmaker.h.cmake
# ----------------------------------------------------------------------------
SET(PACKAGE "icmaker")
SET(PACKAGE_NAME "icmaker")
SET(PACKAGE_STRING "${PACKAGE} ${ICMAKER_VERSION}")
SET(PACKAGE_TARNAME "${PACKAGE}")
SET(PACKAGE_VERSION "${ICMAKER_VERSION}")

# Configure IcMaker:
# ===================================================
SET(ICMAKER_VERBOSE OFF CACHE BOOL "Verbose IcMaker status messages")
SET(ICMAKER_USE_DEPRECATED_MACROS OFF CACHE BOOL "Allow usage of deprecated macros")
SET(ICMAKER_USE_TCMALLOC OFF CACHE BOOL "Link everything against tcmalloc from Google's perftools")

# Detect GNU version:
# ===================================================
IF(CMAKE_COMPILER_IS_GNUCXX)
    EXECUTE_PROCESS(COMMAND ${CMAKE_CXX_COMPILER} --version
                    OUTPUT_VARIABLE CMAKE_ICMAKER_GCC_VERSION_FULL
                    OUTPUT_STRIP_TRAILING_WHITESPACE)

    # Typical output in CMAKE_ICMAKER_GCC_VERSION_FULL: "c+//0 (whatever) 4.2.3 (...)"
    #  Look for the version number
    STRING(REGEX MATCH "[0-9].[0-9].[0-9]" CMAKE_GCC_REGEX_VERSION "${CMAKE_ICMAKER_GCC_VERSION_FULL}")

    # Split the three parts:
    STRING(REGEX MATCHALL "[0-9]" CMAKE_ICMAKER_GCC_VERSIONS "${CMAKE_GCC_REGEX_VERSION}")

    LIST(GET CMAKE_ICMAKER_GCC_VERSIONS 0 CMAKE_ICMAKER_GCC_VERSION_MAJOR)
    LIST(GET CMAKE_ICMAKER_GCC_VERSIONS 1 CMAKE_ICMAKER_GCC_VERSION_MINOR)

    SET(CMAKE_ICMAKER_GCC_VERSION ${CMAKE_ICMAKER_GCC_VERSION_MAJOR}${CMAKE_ICMAKER_GCC_VERSION_MINOR})
    MATH(EXPR CMAKE_ICMAKER_GCC_VERSION_NUM "${CMAKE_ICMAKER_GCC_VERSION_MAJOR}*100 + ${CMAKE_ICMAKER_GCC_VERSION_MINOR}")
    MESSAGE(STATUS "Detected version of GNU GCC: ${CMAKE_ICMAKER_GCC_VERSION} (${CMAKE_ICMAKER_GCC_VERSION_NUM})")

    IF(WIN32)
        EXECUTE_PROCESS(COMMAND ${CMAKE_CXX_COMPILER} -dumpmachine
                  OUTPUT_VARIABLE CMAKE_ICMAKER_GCC_TARGET_MACHINE
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
        IF(CMAKE_ICMAKER_GCC_TARGET_MACHINE MATCHES "64")
            SET(MINGW64 1)
        ENDIF()
    ENDIF()
ENDIF()

# Load additional CMake modules
# ===================================================
IF(ICMAKER_DIRECTORY)
MESSAGE(STATUS "icmaker dir is ${ICMAKER_DIRECTORY}")
    SET(CMAKE_MODULE_PATH "${ICMAKER_DIRECTORY}/CMakeModules/;${CMAKE_MODULE_PATH}")
ELSE()
    SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/;${CMAKE_MODULE_PATH}")
ENDIF()

# Build/install (or not) some apps:
# ===================================================
SET(BUILD_EXAMPLES ON CACHE BOOL "Build all examples")

# Build tests:
# ===================================================
SET(BUILD_TESTS ON CACHE BOOL "Build tests")
ENABLE_TESTING() # Always enable testing, so that at least the "test" target is available, even if the tests are not built!

IF(ICMAKER_DIRECTORY)
    INCLUDE(${ICMAKER_DIRECTORY}/IcMakerMacros.cmake REQUIRED)
ELSE()
    INCLUDE(IcMakerMacros.cmake REQUIRED)
ENDIF()

IF(UNIX)
#    IF(ICMAKER_DIRECTORY)
#        INCLUDE(${ICMAKER_DIRECTORY}/IcMakerFindPkgConfig.cmake OPTIONAL)
#    ELSE()
#        INCLUDE(IcMakerFindPkgConfig.cmake OPTIONAL)
#    ENDIF()
    INCLUDE(CheckFunctionExists)
    INCLUDE(CheckIncludeFile)
ENDIF()

# Enable or disable CUDA (disabled by default because of compiler compatibility
# ===================================================
SET(ENABLE_CUDA OFF CACHE BOOL "Enable CUDA - if off, will cause CUDA find script to not run.")

# Set compiler flags
# ===================================================
IF(CMAKE_COMPILER_IS_GNUCXX)
    SET(ENABLE_PROFILING OFF CACHE BOOL "Enable profiling in the GCC compiler (Add flags: -g -pg)")
    SET(USE_OMIT_FRAME_POINTER ON CACHE BOOL "Enable -fomit-frame-pointer for GCC")
    SET(USE_PERMISSIVE OFF CACHE BOOL "Enable -fpermissive for GCC")
    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES arm*)
        # We can use only -O2 because the -O3 causes gcc crash
        SET(USE_O2 ON CACHE BOOL "Enable -O2 for GCC")
    ENDIF()

    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES amd64*)
        SET(X86_64 1)
    ENDIF()
    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES x86_64*)
        SET(X86_64 1)
    ENDIF()

    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES i686*)
        SET(X86 1)
    ENDIF()
    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES i386*)
        SET(X86 1)
    ENDIF()
    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES x86*)
        SET(X86 1)
    ENDIF()

    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES powerpc*)
        SET(ENABLE_POWERPC ON CACHE BOOL "Enable PowerPC for GCC")
    endif ()

    IF(X86 OR X86_64)
        # enable everything, since the available set of instructions is checked at runtime
        SET(ENABLE_SSE ON CACHE BOOL "Enable SSE for GCC")
        SET(ENABLE_SSE2 ON CACHE BOOL "Enable SSE2 for GCC")
        SET(ENABLE_SSE3 OFF CACHE BOOL "Enable SSE3 for GCC")
        SET(ENABLE_SSSE3 OFF CACHE BOOL "Enable SSSE3 for GCC")
        #SET(ENABLE_SSE4_1 OFF CACHE BOOL "Enable SSE4.1 for GCC")
    ENDIF()
ENDIF()

# ----------------------------------------------------------------------------
# IcMaker Definitions
# ----------------------------------------------------------------------------

SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)

# IcMaker operating system defines
# ===================================================
IF(WIN32)
    ADD_DEFINITIONS(-D_SYSTEM_WIN32_ -D_USE_MATH_DEFINES)
ENDIF(WIN32)

IF(UNIX)
  IF(NOT APPLE)
    ADD_DEFINITIONS(-D_SYSTEM_LINUX_ -D_SYSTEM_POSIX_)
  ELSE()
    ADD_DEFINITIONS(-D_SYSTEM_DARWIN_ -D_SYSTEM_POSIX_)
  ENDIF(NOT APPLE)
ENDIF(UNIX)

ADD_DEFINITIONS(-D_SYSTEM_IDENTIFIER_=${CMAKE_SYSTEM_PROCESSOR}.${CMAKE_SYSTEM_NAME})

# ----------------------------------------------------------------------------
#           Set the maximum level of warnings:
# ----------------------------------------------------------------------------
# May be set to true for development
SET(ICMAKER_WARNINGS_ARE_ERRORS OFF CACHE BOOL "Treat warnings as errors")

SET(EXTRA_C_FLAGS "")
SET(EXTRA_C_FLAGS_RELEASE "")
SET(EXTRA_C_FLAGS_RELWITHDEBINFO "")
SET(EXTRA_C_FLAGS_DEBUG "")
SET(EXTRA_EXE_LINKER_FLAGS "")
SET(EXTRA_EXE_LINKER_FLAGS_RELEASE "")
SET(EXTRA_EXE_LINKER_FLAGS_RELWITHDEBINFO "")
SET(EXTRA_EXE_LINKER_FLAGS_DEBUG "")

IF(MSVC)
    SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /D _CRT_SECURE_NO_DEPRECATE	/D _CRT_NONSTDC_NO_DEPRECATE /D _SCL_SECURE_NO_WARNINGS /D WIN32_LEAN_AND_MEAN /D _WIN32_WINNT=0x0501 /D NOMINMAX")
    # 64-bit portability warnings, in MSVC8
    IF(MSVC80)
        SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /Wp64")
    ENDIF()
    #IF(MSVC90)
    #    SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /D _BIND_TO_CURRENT_CRT_VERSION=1 /D _BIND_TO_CURRENT_VCLIBS_VERSION=1")
    #ENDIF()

    SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /nologo")
	SET(EXTRA_EXE_LINKER_FLAGS "${EXTRA_EXE_LINKER_FLAGS} /nologo")
	SET(EXTRA_EXE_LINKER_FLAGS_DEBUG "${EXTRA_EXE_LINKER_FLAGS_DEBUG} /DEBUG")

    # Remove unreferenced functions: function level linking
#    SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /Gy")
#    SET(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} /Zi")
ENDIF()

IF(CMAKE_COMPILER_IS_GNUCXX)
    # High level of warnings.
    SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Wall")

    IF(USE_CXX11)

=== src/icl_hardware_canopen/CMakeLists.txt ===
# this is for emacs file handling -*- mode: cmake; indent-tabs-mode: nil -*-

# To be used by other modules
SET(ICL_HARDWARE_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/src" CACHE INTERNAL "")
SET(ICL_HARDWARE_IDE_FOLDER "icl_hardware_canopen")


ICMAKER_REGISTER_PACKAGE(icl_hardware_canopen)

ADD_SUBDIRECTORY(src/icl_hardware_canopen)

ICMAKER_CONFIGURE_PACKAGE()

=== src/icl_hardware_canopen/src/icl_hardware_canopen/CMakeLists.txt ===
# this is for emacs file handling -*- mode: cmake; indent-tabs-mode: nil -*-
ICMAKER_SET("icl_hardware_canopen" IDE_FOLDER ${ICL_HARDWARE_IDE_FOLDER})

ICMAKER_ADD_SOURCES(
CanOpenController.cpp
CanOpenReceiveThread.cpp
DS301Group.cpp
DS402Group.cpp
DS301Node.cpp
DS402Node.cpp
SchunkPowerBallNode.cpp
Logging.cpp
SDO.cpp
NMT.cpp
HeartBeatMonitor.cpp
RPDO.cpp
TPDO.cpp
PDO.cpp
EMCY.cpp
helper.cpp
)

ICMAKER_ADD_HEADERS(
CanOpenController.h
CanOpenController.hpp
CanOpenReceiveThread.h
DS301Group.h
DS301Group.hpp
DS402Group.h
DS402Group.hpp
DS301Node.h
DS402Node.h
SchunkPowerBallNode.h
Logging.h
SDO.h
NMT.h
HeartBeatMonitor.h
PDO.h
RPDO.h
TPDO.h
EMCY.h
ds301.h
ds402.h
sync.h
helper.h
exceptions.h
)

ICMAKER_LOCAL_CPPDEFINES(-DICL_HARDWARE_CAN_EXPORT_SYMBOLS)
ICMAKER_GLOBAL_CPPDEFINES(-D_IC_BUILDER_ICL_HARDWARE_CAN_ -DOSNAME_LINUX)
ICMAKER_INCLUDE_DIRECTORIES(${ICL_HARDWARE_INCLUDE_DIRS})


ICMAKER_INTERNAL_DEPENDENCIES(
  icl_core
  icl_hardware_can
)

# Websockets are a later expansion that is not considered at the moment but prepared for
ICMAKER_DEPENDENCIES(OPTIONAL EXPORT
 icl_comm_websocket
)

ICMAKER_BUILD_LIBRARY()
ICMAKER_INSTALL_HEADERS(${icmaker_target})

ADD_SUBDIRECTORY(test)
add_subdirectory(examples)

=== src/icl_hardware_canopen/src/icl_hardware_canopen/examples/CMakeLists.txt ===
ICMAKER_SET("icl_hardware_canopen_example") # IDE_FOLDER ${ICL_HARDWARE_IDE_FOLDER})

ICMAKER_ADD_SOURCES(
  simple_example.cpp
)

ICMAKER_DEPENDENCIES(
  icl_core
  icl_hardware_canopen
  Boost_FILESYSTEM
  Boost_SYSTEM
  Boost_THREAD
)

ICMAKER_BUILD_PROGRAM()


ICMAKER_SET("icl_hardware_canopen_minimal_example") # IDE_FOLDER ${ICL_HARDWARE_IDE_FOLDER})

ICMAKER_ADD_SOURCES(
  minimal_example.cpp
)

ICMAKER_DEPENDENCIES(
  icl_core
  icl_hardware_canopen
  Boost_FILESYSTEM
  Boost_SYSTEM
  Boost_Thread
)

ICMAKER_BUILD_PROGRAM()


ICMAKER_SET("icl_hardware_canopen_pg70_example") # IDE_FOLDER ${ICL_HARDWARE_IDE_FOLDER})

ICMAKER_ADD_SOURCES(
  pg70_example.cpp
)

ICMAKER_DEPENDENCIES(
  icl_core
  icl_hardware_canopen
  Boost_THREAD
  Boost_SYSTEM
  Boost_FILESYSTEM
)

ICMAKER_BUILD_PROGRAM()

=== src/icl_hardware_canopen/src/icl_hardware_canopen/test/CMakeLists.txt ===
# this is for emacs file handling -*- mode: c++; indent-tabs-mode: nil -*-

# -- BEGIN LICENSE BLOCK ----------------------------------------------
# -- END LICENSE BLOCK ------------------------------------------------

#----------------------------------------------------------------------
#file
#
# \author  Felix Mauch <mauch@fzi.de>
# \date    2015-10-7
#
#----------------------------------------------------------------------

#### CanOpen test suite ####
ICMAKER_SET("icl_hardware_canopen_test") # IDE_FOLDER ${ICL_HARDWARE_IDE_FOLDER})

ICMAKER_ADD_SOURCES(
  testing_main.cpp
  test_sdo.cpp
  test_emcy.cpp
)

ICMAKER_DEPENDENCIES(
  icl_core
  icl_hardware_canopen
  Boost_SYSTEM
  Boost_THREAD
)

IF(Boost_FOUND)
  IF(BUILD_SHARED_LIBS)
    ICMAKER_LOCAL_CPPDEFINES("-DBOOST_TEST_DYN_LINK")
  ENDIF(BUILD_SHARED_LIBS)
ENDIF(Boost_FOUND)
ICMAKER_EXTERNAL_DEPENDENCIES(
  Boost_UNIT_TEST_FRAMEWORK
)

ICMAKER_BUILD_TEST()

=== debian/changelog ===
ros-indigo-schunk-canopen-driver (1.0.6-0trusty) trusty; urgency=high

  * made xacro usage conform to current standards from jade and kinetic
  * implement prepareSwitch instead of canSwitch
  * fix: do not start boost thread explicitly
  * Contributors: Felix Mauch

 -- Georg Heppner <heppner@fzi.de>  Mon, 16 May 2016 22:00:00 -0000

ros-indigo-schunk-canopen-driver (1.0.5-0trusty) trusty; urgency=high

  * added missing runtime dependencies
  * Contributors: Felix Mauch

 -- Georg Heppner <heppner@fzi.de>  Wed, 11 May 2016 22:00:00 -0000

ros-indigo-schunk-canopen-driver (1.0.4-0trusty) trusty; urgency=high

  * use the "auto" keyword for the identifier in the node executables
  * made the check for the resource path safe to null pointers
  * install launch files.
  * Contributors: Felix Mauch

 -- Georg Heppner <heppner@fzi.de>  Tue, 10 May 2016 22:00:00 -0000

ros-indigo-schunk-canopen-driver (1.0.3-0trusty) trusty; urgency=high

  * fix: Dependencies were wrong and others were missing
  * Updated and sorted package dependencies
  * Corrected maintainer name
  * Contributors: Felix Mauch

 -- Georg Heppner <heppner@fzi.de>  Tue, 03 May 2016 22:00:00 -0000

ros-indigo-schunk-canopen-driver (1.0.2-0trusty) trusty; urgency=high

  * remove icl_hardware_canopen from dependencies as it is provided by this
    package
  * Contributors: Felix Mauch

 -- Felix Mauch <heppner@fzi.de>  Sun, 01 May 2016 22:00:00 -0000

ros-indigo-schunk-canopen-driver (1.0.1-0trusty) trusty; urgency=high

  * First initial release of the schunk_canopen_driver for ROS
  * Contributors: Andreas Hermann, Felix Mauch, Georg Heppner, Pascal Becker

 -- Felix Mauch <heppner@fzi.de>  Thu, 07 Apr 2016 22:00:00 -0000

=== debian/control ===
Source: ros-indigo-schunk-canopen-driver
Section: misc
Priority: extra
Maintainer: Georg Heppner <heppner@fzi.de>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-actionlib, ros-indigo-catkin, ros-indigo-control-msgs, ros-indigo-controller-manager, ros-indigo-fzi-icl-can, ros-indigo-fzi-icl-core, ros-indigo-hardware-interface, ros-indigo-joint-limits-interface, ros-indigo-message-generation, ros-indigo-roscpp, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-urdf
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-schunk-canopen-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-actionlib, ros-indigo-control-msgs, ros-indigo-controller-manager, ros-indigo-fzi-icl-can, ros-indigo-fzi-icl-core, ros-indigo-hardware-interface, ros-indigo-joint-limits-interface, ros-indigo-message-runtime, ros-indigo-robot-state-publisher, ros-indigo-ros-controllers, ros-indigo-roscpp, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-urdf, ros-indigo-xacro
Description: The schunk_canopen_driver package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-schunk-canopen-driver//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
